package goap

type CapabilitiesData struct {
	Next         BaseApChain
	Capabilities []map[string]any
}

func (capabilitiesdata *CapabilitiesData) GetSelfOrBase() (BaseApChain, bool) {
	return capabilitiesdata.Next, true
}

func (capabilitiesdata *CapabilitiesData) MarshalToMap() map[string]any {
	return appendWithKey(
		capabilitiesdata.Next.MarshalToMap(),
		KEY_LITEPUB_CAPABILITIES,
		capabilitiesdata.Capabilities,
	)
}

type OauthRegistrationEndpointData struct {
	FullIdType
}

func (oauthregistrationendpointdata *OauthRegistrationEndpointData) GetSelfOrBase() (BaseApChain, bool) {
	return oauthregistrationendpointdata.FullIdType.GetSelfOrBase()
}

func (oauthregistrationendpointdata *OauthRegistrationEndpointData) MarshalToMap() map[string]any {
	return oauthregistrationendpointdata.FullIdType.MarshalToMapWithName(
		KEY_ACTIVITYSTREAMS_OAUTHAUTHORIZATION,
	)
}
