package goap

type MisskeySummaryData struct {
	Next    BaseApChain
	Summary string
}

func (misskeysummarydata *MisskeySummaryData) GetSelfOrBase() (BaseApChain, bool) {
	return misskeysummarydata.Next, true
}

func (misskeysummarydata *MisskeySummaryData) MarshalToMap() map[string]any {
	return appendWithKey(
		misskeysummarydata.Next.MarshalToMap(),
		KEY_MISSKEY_MKSUMMARY,
		[]map[string]any{{KEY_VALUE: misskeysummarydata.Summary}},
	)
}

type IsCatData struct {
	Next  BaseApChain
	IsCat bool
}

func (iscatdata *IsCatData) GetSelfOrBase() (BaseApChain, bool) {
	return iscatdata.Next, true
}

func (iscatdata *IsCatData) MarshalToMap() map[string]any {
	return appendWithKey(
		iscatdata.Next.MarshalToMap(),
		KEY_MISSKEY_ISCAT,
		[]map[string]any{{KEY_VALUE: iscatdata.IsCat}},
	)
}

type SpeakAsCatData struct {
	Next        BaseApChain
	SpeaksAsCat bool
}

func (iscatdata *SpeakAsCatData) GetSelfOrBase() (BaseApChain, bool) {
	return iscatdata.Next, true
}

func (iscatdata *SpeakAsCatData) MarshalToMap() map[string]any {
	return appendWithKey(
		iscatdata.Next.MarshalToMap(),
		KEY_FIREFISH_SPEAKASCAT,
		[]map[string]any{{KEY_VALUE: iscatdata.SpeaksAsCat}},
	)
}
